package com.iden.common.videotool;

import com.iden.common.util.DateUtils;
import lombok.extern.slf4j.Slf4j;

import java.util.Date;

@Slf4j
public class VideoTool {
    /**
     * 视频分解为图片
     * @param ffmpegPath
     * @param videoFilePath
     * @param saveDir
     * @param shootEndTime
     * @return
     * @throws Exception
     */
    public static Long fetchAllPic(String ffmpegPath,String videoFilePath, String saveDir, Date shootEndTime) throws Exception {
        Long endTime = shootEndTime.getTime() ;

        //ms
        long duration = 0L;

        String cmd = ffmpegPath +  " -y -i " + videoFilePath + " -r 1 " + saveDir + "%04d.jpg";

        log.info("开始运行视频分解为图片命令：" + cmd);
        Runtime.getRuntime().exec(cmd);
        log.info("视频分解为图片完成");

        return duration;
    }

    /**
     * 视频剪辑
     * @param ffmpegPath
     * @param beginTime
     * @param endTime
     * @param videoSrcPath
     * @param targetPath
     */
    public static void cutVideo(String ffmpegPath, String beginTime,String endTime,String videoSrcPath,String targetPath) throws Exception {

        Long duration = DateUtils.betweenTimeSS(beginTime, endTime); //s

        String cmd = ffmpegPath + " -ss " + beginTime + " -i " + videoSrcPath
                + " -t " + duration + " -c:v copy -c:a copy " + targetPath;

        log.info("开始运行视频剪辑命令：" + cmd);
        Runtime.getRuntime().exec(cmd);
        log.info("视频剪辑完成");

    }
}
